Presentation is loading. Please wait.

Presentation is loading. Please wait.

A Survey on the Tree augmentation problem

Similar presentations


Presentation on theme: "A Survey on the Tree augmentation problem"— Presentation transcript:

1 A Survey on the Tree augmentation problem
Guy Kortsarz

2 Augmenting edge connectivity from 1 to 2
Given: undirected graph G(V,E) and a set of extra legal for addition edges F with cost c(e) for every edge e Required: a subset F’ F of minimum cost so that G(V,E+F’) is 2-edge-connected

3 Bi-Connected Components
G A H F B D E C

4 The tree augmentation problem
Input: A tree T(V,E) and a separate set edge F with cost on every link Output: Add minimum cost set of links F’ from F so there will be no bridges (G+F’ is 2EC)

5 Another way of posing the problem
A family of sets is laminar is for any two set A,B, either one set contains the other or the sets are disjoint. A laminar family is a tree. So our problem is equivalent to covering Laminar families Part of a subject to know: uncrossing.

6 Shadow Completion Part of the shadows added

7 Shadows-Minimal Solutions
If a link in the optimum can be replaced by a proper shadow and the solution is still feasible, do it. Claim: in any SMS, the leaves have degree 1

8 Is there a difference between uniform and arbitrary weights?
We do not know. Get used to the feeling. However, people started working on breaking the ratio of 2 for uniform cost. As of now there is a difference even if the maximum link cost is constant. The first part of this talk: the unweighted case.

9 Approximation ratios for the uniform cost case
First to break the ratio of 2 was Nagamochi. About 40 pages paper. Ratio roughly 1.9. DAM In 2016 after 15 years of simplifications, K, Nutov gave 1.5 ratio (combinatorial) TALG 2016. Cheriyan and Gao gave the same ratio with similar algorithm but novel analysis

10 Continued Cheriyan et al used Lift and Project to get the 3/2 ratio. Interesting idea: proving ratio of a combinatorial algorithm by Lift and Project. Algorithmica 2018 Best known approximation ratio by Grandoni Kalaitzis Zenklusen. LP based. STOC 2018.

11 What do we know on the basic LP?
link j covers edge e xj ≥1, xj ≥0 J. Cheriyan H. Karloff R. Khandekar J. ̈Konemann. 3/2 IG. The two in green are now working in Wall Street. Nutov: IG at most 2-2/15.

12 Any solution has a matching on the leaves
Therefore it is natural to find a maximum matching on the leaves. Every combinatorial algorithm does just that. But the dual fitting of K. Nutov that finds a maximal matching. What about an algorithm that finds a maximum matching, contract and iterate? Not better than 2.

13 Taking any matchings give ratio 2

14 Problematic structure: Stem
A link whose contraction creates a leaf STEM Twin Link

15 How to design a lower bound trivially
Say we want a 3/2 ratio. Consider OPT Each leaf to leaf link in OPT gets 3/2 units and each unmatched leaf has 3/2. But the other end of the unmatched link is not a leaf. Transfer ½ from the unmatched leaf to the non leaf leaving credit 1 for unmatched leaf.

16 We do not know the optimum
So we do it with a maximum matching Easy to see: each matched link credit 3/2 and each unmatched credit 1, and stem link credit 2 is a lower bound. Because our matching can only be larger.

17 Problematic structure: Stem
A link whose contraction creates a leaf 3/2+1/2=2 STEM 1 Twin Link

18 Main idea Find a tree with k+1 credit that can be covered with k links
Leave 1 unit on the root. 1 K+1

19 Problematic structure: Stem
Since stem link has credit 2 add link and leave 1. STEM Twin Link

20 We cover a tree similar to Minimally Leaf Closed.
Minimally leaf closed means that links touching the leaves do not go outside the tree, and the tree is minimal with respect to this property. We need 1 to take matched links so ½ spare. Two matched pairs give extra credit 1. Put 1 on the the new leaf. Difficulty: trees with one matched pair.

21 Integrality gap of better than 2: for the unweighted case.
If the twin link is taken then there is a link to the stem with the same value. STEM Twin Link

22 First IG better than 2, was for uniform costs K,Nutov
K. Nutov. Include the mentioned valid inequality, without whom, we could not show any integrality gap better than 2. The more interesting algorithm that shows 7/4 integrality gap is a dual fitting. We do not need to solve an LP In fact we only need to find a maximal matching. Very fast algorithm.

23 The weighted case: no leaf closed trees
We may assume it’s a metric, since the problem on a path is polynomial. Cheriyan Jordan and Ravi: the problem is hard even if the links are an Hamiltonian path on the leaves. A ½ integral solution gives 4/3 ratio. But in most cases not half integral.

24 The weighted case: no leaf closed trees
If the diameter is constant then there is a better than 2 ratio: 1+ln 2 in time nf(D) Cohen and Nutov. Landau and Nutov: study the case links are leaf to leaf. The problem parametrize by opt is fixed parameter tractable. Due to Marx et al

25 Perhaps the simplest idea to get a ratio 2 for TAP.
If all the links inside principal trees are up links (from an ancestor to a descendant) then we get that the Matrix is totally unimodular This means that Basic Feasible Solution has integral entries. Double an link (u,v). Say that w is the LCA, change to (u,w) (v,w)

26 Lin : links inside principal trees
Let optin be the cost of LinOPT Let optcr be the rest of the optimum. Note that the trivial algorithm gives a solution of cost optcr +2optin Only if optin has almost all the cost would this be a ratio 2.

27 A significant breakthrough
We were surprised by a paper of Adjiashvili that gave a ratio for TAP if the maximum weight is bounded by a constant. The paper had a truly original approach and many pretty ideas. For uniform cost gave 5/3 LP based. Improving K,Nutov 7/4

28 Some remarks We root the tree at a vertex r.
Make sure no edge is covered by more than 2/ flow. Denote by M the maximum cost of a link covered by at most 2/ Thus every edge is covered by at most 2M/ cost.

29 Some more definitions The trees rooted at childrens of r are called principal trees. Also, a principal tree is called heavy if the LP cost inside the tree (links both of its endpoints are in the principal tree) is at least 2M/2 We only separate heavy trees from the large tree.

30 An Overview Principal trees are trees rooted at the children of the root r. Principal edges are edges from the root to a child. Divide and conquer: remove heavy trees.

31 Overview Principal trees are trees rooted at the children of the root r. Principal edges are edges from the root to a child. Divide and conquer:

32 How to keep the LP legal: cut at shadows

33 How to keep the LP legal: cut at shadows
LP is legal afte we cut at shaddows.

34 The trees now do not contain all edges
We need to explain how we cover with negliable cost edges that are removed by the divide and conquer. Namely, principal edges from the root to a child that roots a heavy tree. We use the fact that we separated only heavy trees.

35 Say that we deleted k big trees
Since every edge is covered by at most 2/ and M is the maximum cost covering these k trees costs at most 2Mk/ Since every removed tree is heavy, the cost of separated trees is at least 2Mk/2 Hence in total we pay at most opt

36 After iteratively divide and conquer
The principal trees that remain are all of low cost, namely at most 2Mk/2 cost. Every links has a cost of at least 1 Thus the number of leaves (each having a fractional cover of at least 1) is at most 2Mk/2 This is constant, since M is.

37 Dealing with principal trees of constant cost
This case is divides into two sub cases Depending on if the crossing links are fractionally heavier. In this case we reduce to a well known problem: Edge cover. Or the internal links are fractionally heavier. Solve optimally each small tree by exhaustive search.

38 The internal fraction is smaller
Say that the fractional cost of covering the trees is much less than the cost of edges between principal trees. The vertex r belongs to all the covering paths. This is equivalent to Edge Cover. The LP will not solve it exactly (more constrains are needed). But gives 4/3 approximation.

39 The edge cover polytope
Say that we want to cover a set U by edges. So x((v))≥1 for every yU. To be integral, you have to add the odd cut inequalities. If U has odd size we get an odd inequality for U.

40 Covering U can not be done by a perfect matching
The odd cut inequality: the number of links touching U required to cover U is at least (|U|+1)/2 If you add all the odd cut inequalities then the solution is exact. But it was shown that without the odd cut inequalities you get at most 4opt/3.

41 The second case We can compute the optimum of tree rooted at a child in polynomial time. We make sure that the LP is at least the integral optimum. It’s a valid inequality. The LP should have value at least opt because OPT is a valid solution. This is almost never used since we almost never know opt.

42 People may have thought
The 4/3 factor should be removed. No need to solve optimally on small forests. Trees will do. Adding the odd cut inequalities is highly natural (makes the Edge Cover integral). We discuss the work of Fiorini, Groß, Könemann, and Sanità

43 Doubling crossing edges

44 Doubling crossing edges

45 Remove all crossing edges
We are talking on the case that crossing links dominate. The authors suggested two things: remove all crossing links. This increases the cost: 2optcr +optin The crossing edges have been replaced by up edges.

46 How do we solve after adding the Odd-Cut Constraints?
The authors add the odd cut constrains and show that its possible to solve the LP integraly. Based on very non trivial argument. Thus the problem after cutting crossing edges is polynomial time solvable. Thus gives cost 2optcr+optin

47 How does the 3/2+  follow Always known optcr+2optin
Recall that to get to small trees we already payed opt Other than that the sum of 2optcr+optin and optcr+2optin is 3optcr+3optin Thus one of the two solutions has cost 3opt/2. 3/2+  ratio.

48 Based on this paper Nutov gave an exp(M,1/) time to solve the problem when the trees are small. Because Nutov showed that it is enough to solve the bundle inequalities on trees. Not on forests. The ratio is the same, namely 3/2+ However given the time to solve optimally the case of small trees, the ratio works for M=O(log n)

49 How to improve the 3/2 for unweighted edges
Given a small tree, a simple use of LP, gives a solution that is a convex combination optimal solutions. The ideas of reducing the cost is saying that the cost was not as large to begin with. We only added ccr + 2cin – cup cost Upward edges were not duplicated.

50 Replacing two up links by a crossing link
v

51 The link between u and v replaces two up links

52 Choosing a solution for small trees randomly
Each solution for a principal tree is a convex combination of optimal trees. Thus for every principal tree, select and optimum at random. If (u,v) is a crossing link then the events that they are in the union of solutions is independent. Because they belong yo different trees.

53 Moreover Each link belongs to the solution with probability xe
We can define a matching instance with links that can replace two up links. The key lemma: Large Matching. This uses properties of a BFS of the LP. We show intuition next slide

54 Consider a crossing edge
The side link if belongs to OPT, has a clear affect u

55 Consider a crossing edge
The links that cover edges from the children to u must be a up links. u

56 Consider a crossing edge
This follows form shaddow minimality. u

57 Open problem Can TAP be approximated within 2-??
The problem is open 36 years. We never published anything on the vertex case. We thought we have better than 2. We may be wrong. Since we did not ever really checked. Increasing connectivity from 2 to 3? A much harder problem probably.


Download ppt "A Survey on the Tree augmentation problem"

Similar presentations


Ads by Google